package com.karneim.util.collection.set;

/**
 * berschrift:
 * Beschreibung:
 * Copyright:     Copyright (c) 2001
 * Organisation:
 * @author
 * @version 1.0
 */

import java.io.Serializable;

public interface ISet_char extends Serializable,Cloneable {

  public interface Iterator {
    public boolean hasNext();
    public char next();
  }

  public boolean contains(char ch);
  public boolean isEmpty();
  public int size();
  public ISet_char.Iterator iterator();


//  public ISet_char getComplement();

  /**
   * return this.addAll(set).
   * return C = A | B = this | set
   */
//  public ISet_char getUnionSet(ISet_char set);

  /**
   * return this.retainAll(set).
   * return C = A & B = this & set
   */
//  public ISet_char getIntersectionSet(ISet_char set);

  /**
   * return this.removeAll(set).
   * return C = A \ B = this \ set
   */
//  public ISet_char getDifferenceSet(ISet_char set);



  public void clear();

  public boolean add(char ch);
  public boolean remove(char ch);

  public void complement();

  public void addAll(String chars);

  /**
   * adds all chars from set to this ISet_char without adding doublicates.
   * returns the number of chars added to this ISet_char.
   */
  public void addAll(ISet_char set);

  /**
   * Removes from this set all of its elements that are contained in the specified set (optional operation).
   * returns the number of chars that were removed.
   */
  public void removeAll(ISet_char set);

  public void retainAll(ISet_char set);

  public Object clone();

}